#include <cstdlib>
#include <iostream>

#include <SDL/SDL.h>

#include "imagemono.h"
#include "SDL_flo.h"

#include "debruitage.h"


using namespace std;

/***********************************************
 * Code source du cours sur le dbruitage aux quations aux drives partielles
 *
 * Auteur : HUMBERT Florent
 ************************************************/


int main(int argc, char *argv[])
{
    ImageMono source;
    ImageMono* dest;
    G_surface* surf;
    G_couleur coul(255, 255, 255);
    G_surface* origine;

    G_fenetre fenetre(512, 256);

    source.ChargerPPM("lenna_bruit_faible.ppm");
    origine =  ImageMono2G_surface(&source);
  //  dest = debruitageTikhonov(source, 10, 0.1, 1.0);
cerr<<"test";
   //  dest = debruitageTikhonov(source, 100, 5, 0.01);

 // dest = debruitageHypersurface(source, 200, 0.25, 1.0);
    dest = debruitageHypersurface(source, 200, 250, 0.001);
    // dest = debruitageVariation(source, 400, 250, 0.001);


    surf = ImageMono2G_surface(dest);
    fenetre.EcrireG_surfaceDec(surf);
    fenetre.EcrireG_surface(origine);

    fenetre.Afficher();
    //fenetre.Sauver("b3.bmp");
    //dest->SauvegarderPPM("tik-100-5-001.ppm");

    fenetre.Attendre();


    delete dest;
    delete surf;
    delete origine;

    return EXIT_SUCCESS;
}
